de.esprit.common.gui.table

## Class AbstractObjectTable<T>

- java.lang.Object
- - java.awt.Component
  - - java.awt.Container
    - - javax.swing.JComponent
      - - javax.swing.JTable
        - - de.esprit.common.gui.table.AbstractObjectTable<T>

- All Implemented Interfaces:
    DataLoadEvent.Source, EnvStorable, Steppable, Clearable, Dumpable, java.awt.image.ImageObserver, java.awt.MenuContainer, java.io.Serializable, java.util.EventListener, javax.accessibility.Accessible, javax.swing.event.CellEditorListener, javax.swing.event.ListSelectionListener, javax.swing.event.RowSorterListener, javax.swing.event.TableColumnModelListener, javax.swing.event.TableModelListener, javax.swing.Scrollable
  Direct Known Subclasses:
    AbstractMarkableTable, ApplicationTable, DBRecordTable

      public abstract class AbstractObjectTable<T>
      extends javax.swing.JTable
      implements Dumpable, Clearable, EnvStorable, Steppable, DataLoadEvent.Source

  This is a JTable width many basic functionality added. I.e. it implements a double-click support and also provides a set of inner actions and convenience methods.
  Author:
    Rainer Buesch
  See Also:
    Serialized Form

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class javax.swing.JTable

      `javax.swing.JTable.AccessibleJTable, javax.swing.JTable.DropLocation, javax.swing.JTable.PrintMode`

    - ### Nested classes/interfaces inherited from class javax.swing.JComponent

      `javax.swing.JComponent.AccessibleJComponent`

    - ### Nested classes/interfaces inherited from class java.awt.Container

      `java.awt.Container.AccessibleAWTContainer`

    - ### Nested classes/interfaces inherited from class java.awt.Component

      `java.awt.Component.AccessibleAWTComponent, java.awt.Component.BaselineResizeBehavior, java.awt.Component.BltBufferStrategy, java.awt.Component.FlipBufferStrategy`

  - ### Field Summary

    - ### Fields inherited from class javax.swing.JTable

      `AUTO_RESIZE_ALL_COLUMNS, AUTO_RESIZE_LAST_COLUMN, AUTO_RESIZE_NEXT_COLUMN, AUTO_RESIZE_OFF, AUTO_RESIZE_SUBSEQUENT_COLUMNS, autoCreateColumnsFromModel, autoResizeMode, cellEditor, cellSelectionEnabled, columnModel, dataModel, defaultEditorsByColumnClass, defaultRenderersByColumnClass, editingColumn, editingRow, editorComp, gridColor, preferredViewportSize, rowHeight, rowMargin, rowSelectionAllowed, selectionBackground, selectionForeground, selectionModel, showHorizontalLines, showVerticalLines, tableHeader`

    - ### Fields inherited from class javax.swing.JComponent

      `accessibleContext, listenerList, TOOL_TIP_TEXT_KEY, ui, UNDEFINED_CONDITION, WHEN_ANCESTOR_OF_FOCUSED_COMPONENT, WHEN_FOCUSED, WHEN_IN_FOCUSED_WINDOW`

    - ### Fields inherited from class java.awt.Component

      `BOTTOM_ALIGNMENT, CENTER_ALIGNMENT, LEFT_ALIGNMENT, RIGHT_ALIGNMENT, TOP_ALIGNMENT`

    - ### Fields inherited from interface java.awt.image.ImageObserver

      `ABORT, ALLBITS, ERROR, FRAMEBITS, HEIGHT, PROPERTIES, SOMEBITS, WIDTH`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `AbstractObjectTable(AbstractObjectTableModel<T> model)`
    `AbstractObjectTable(AbstractObjectTableModel<T> model, EnvStore envStore)`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `addActionListener(java.awt.event.ActionListener l)` Adds a listener to react on double clicks.
    `void` | `addDataLoadListener(DataLoadEvent.Listener l)`
    `void` | `addEnvProperties(EnvMap props)` This method is called on the implementing class in order to give it a chance to fill the passed Properties object with key-value pairs that should be saved in the environment properties file.
    `void` | `addIndexChangeListener(IndexChangeEvent.Listener l)`
    `void` | `addListSelectionListener(javax.swing.event.ListSelectionListener l)`
    `int` | `addObject(T obj)` Inserts a record for the given object in a way that it keeps the current selection (if any).
    `void` | `addObjects(java.util.Collection<T> objs)`
    `void` | `addObjects(T[] objs)`
    `void` | `addTableModelListener(javax.swing.event.TableModelListener l)`
    `protected void` | `adjustSelection(int rowIndex)`
    `void` | `clear()` Drops all rows from the underlying TableModel
    `protected int` | `configurePreferredDumpDialogColumns()`
    `protected int` | `configurePreferredDumpDialogRows()`
    `int` | `deleteObject(java.lang.Object obj)`
    `protected void` | `deleteRow(int rowIndex)` May be overridden if something special needs to happen before the object is actually deleted from the TableModel.
    `protected int` | `deleteRow(java.lang.Object obj)` Is called by the the inner delete-selected-row Notify when fired.
    `T` | `dropObject(int rowIndex)` Drops the object at the given index from the table.
    `int` | `dropObject(java.lang.Object obj)` Drops the given object from the table if it can be found based on its equals() method.
    `int` | `dropObject(java.lang.Object obj, boolean isAdjustSelection)`
    `void` | `dumpSelectedObject()`
    `void` | `first()`
    `de.esprit.common.gui.table.AbstractObjectTable.MyTableClearAction` | `getActionClearContent()`
    `de.esprit.common.gui.table.AbstractObjectTable.MyClearSelectionAction` | `getActionClearSelection()`
    `de.esprit.common.gui.table.AbstractObjectTable.MyDeleteSelectedRowAction` | `getActionDeleteSelectedRow()` Deletes the selected record from the table.
    `de.esprit.common.gui.table.AbstractObjectTable.MyDropSelectedRowAction` | `getActionDropSelectedRow()`
    `de.esprit.common.gui.table.AbstractObjectTable.MyDumpTableDataAction` | `getActionDumpTableData()`
    `de.esprit.common.gui.table.AbstractObjectTable.MyLoadTableDataAction` | `getActionLoadTableData()` Clears and reloads the table data.
    `de.esprit.common.gui.table.AbstractObjectTable.MyRowDetailsAction` | `getActionRowDetails()` Pops up a TableRowDumpDialog showing the (Dumpable) details of the selected record.
    `java.util.List<T>` | `getAllObjects()` Returns all Objects contained in the TableModel.
    `int` | `getCurrentIndex()`
    `protected java.lang.String` | `getEnvKey()`
    `AbstractObjectTableModel<T>` | `getModel()`
    `T` | `getObject(int index)` Delegates to the underlying TableModel.
    `java.awt.Dimension` | `getPreferredScrollableViewportSize()`
    `int` | `getRecordCount()`
    `int` | `getSelectedIndex()` Returns the index of the currently selected row.
    `T` | `getSelectedObject()` Returns the Object in the currently selected row.
    `java.util.List<T>` | `getSelectedObjects()` Returns all Objects in the currently selected rows.
    `IndexSelectionModel` | `getSelectionModel()`
    `boolean` | `hasRangeSelected()` Tells if a range selection exists.
    `boolean` | `hasSelection()` Returns true if any row is selected.
    `int` | `indexOf(java.lang.Object obj)` Delegates to the underlying TableModel.
    `void` | `initFromEnvStore(EnvStore envStore)` Restores all column sizes as they are stored in the EnvStore.
    `boolean` | `isChangeConfirmed()`
    `boolean` | `isEmpty()`
    `boolean` | `isSelectionEmpty()`
    `boolean` | `isSortAscending()`
    `void` | `last()`
    `void` | `load()`
    `protected boolean` | `matchesTypedString(java.lang.Object obj, java.lang.String typedStr)`
    `boolean` | `next()`
    `boolean` | `previous()`
    `void` | `removeActionListener(java.awt.event.ActionListener l)`
    `void` | `removeDataLoadListener(DataLoadEvent.Listener l)`
    `void` | `removeIndexChangeListener(IndexChangeEvent.Listener l)`
    `void` | `removeListSelectionListener(javax.swing.event.ListSelectionListener l)`
    `void` | `removeTableModelListener(javax.swing.event.TableModelListener l)`
    `void` | `scrollToRow(int rowIndex)` Scrolls to the given row index to make it visible.
    `java.lang.Object` | `selectObject(int index)` Selects the row at the given index.
    `java.lang.Object` | `selectObject(T obj)` Searches the given Object in the TableModel and selects it.
    `void` | `selectRow(int rowIndex)`
    `void` | `selectRow(int rowIndex, boolean isScrollVisible)` Selects the specified row and scrolls it to be visible.
    `boolean` | `setCurrentIndex(int rowIndex)`
    `void` | `setHeaderRenderer(javax.swing.table.TableCellRenderer r)`
    `void` | `setObject(int index, T obj)` Delegates to the TableModel and ensures that a selection event is fired if the affected object is currently selected.
    `void` | `setSelectionMode(ListSelectionMode mode)`
    `void` | `setSortAscending(boolean isAscending)`
    `java.lang.String` | `toDumpString()` Returns a multi-line String that shows the values (name=value) of all important state variables of this object.
    `DumpString` | `toDumpString(DumpString s)` This method allows subclasses to add values to the existing DumpString of the superclass.
    `java.lang.String` | `toString()` Returns a single line String that shows the values of the most important state variables of this object.
    `ToString` | `toString(ToString s)` This method allows subclasses to add values to the existing ToString of the superclass.

    - ### Methods inherited from class javax.swing.JTable

      `addColumn, addColumnSelectionInterval, addNotify, addRowSelectionInterval, changeSelection, clearSelection, columnAdded, columnAtPoint, columnMarginChanged, columnMoved, columnRemoved, columnSelectionChanged, configureEnclosingScrollPane, convertColumnIndexToModel, convertColumnIndexToView, convertRowIndexToModel, convertRowIndexToView, createDefaultColumnModel, createDefaultColumnsFromModel, createDefaultDataModel, createDefaultEditors, createDefaultRenderers, createDefaultSelectionModel, createDefaultTableHeader, createScrollPaneForTable, doLayout, editCellAt, editCellAt, editingCanceled, editingStopped, getAccessibleContext, getAutoCreateColumnsFromModel, getAutoCreateRowSorter, getAutoResizeMode, getCellEditor, getCellEditor, getCellRect, getCellRenderer, getCellSelectionEnabled, getColumn, getColumnClass, getColumnCount, getColumnModel, getColumnName, getColumnSelectionAllowed, getDefaultEditor, getDefaultRenderer, getDragEnabled, getDropLocation, getDropMode, getEditingColumn, getEditingRow, getEditorComponent, getFillsViewportHeight, getGridColor, getIntercellSpacing, getPrintable, getRowCount, getRowHeight, getRowHeight, getRowMargin, getRowSelectionAllowed, getRowSorter, getScrollableBlockIncrement, getScrollableTracksViewportHeight, getScrollableTracksViewportWidth, getScrollableUnitIncrement, getSelectedColumn, getSelectedColumnCount, getSelectedColumns, getSelectedRow, getSelectedRowCount, getSelectedRows, getSelectionBackground, getSelectionForeground, getShowHorizontalLines, getShowVerticalLines, getSurrendersFocusOnKeystroke, getTableHeader, getToolTipText, getUI, getUIClassID, getUpdateSelectionOnSort, getValueAt, initializeLocalVars, isCellEditable, isCellSelected, isColumnSelected, isEditing, isRowSelected, moveColumn, paramString, prepareEditor, prepareRenderer, print, print, print, print, print, processKeyBinding, removeColumn, removeColumnSelectionInterval, removeEditor, removeNotify, removeRowSelectionInterval, resizeAndRepaint, rowAtPoint, selectAll, setAutoCreateColumnsFromModel, setAutoCreateRowSorter, setAutoResizeMode, setCellEditor, setCellSelectionEnabled, setColumnModel, setColumnSelectionAllowed, setColumnSelectionInterval, setDefaultEditor, setDefaultRenderer, setDragEnabled, setDropMode, setEditingColumn, setEditingRow, setFillsViewportHeight, setGridColor, setIntercellSpacing, setModel, setPreferredScrollableViewportSize, setRowHeight, setRowHeight, setRowMargin, setRowSelectionAllowed, setRowSelectionInterval, setRowSorter, setSelectionBackground, setSelectionForeground, setSelectionMode, setSelectionModel, setShowGrid, setShowHorizontalLines, setShowVerticalLines, setSurrendersFocusOnKeystroke, setTableHeader, setUI, setUpdateSelectionOnSort, setValueAt, sizeColumnsToFit, sizeColumnsToFit, sorterChanged, tableChanged, unconfigureEnclosingScrollPane, updateUI, valueChanged`

    - ### Methods inherited from class javax.swing.JComponent

      `addAncestorListener, addVetoableChangeListener, computeVisibleRect, contains, createToolTip, disable, enable, firePropertyChange, firePropertyChange, firePropertyChange, fireVetoableChange, getActionForKeyStroke, getActionMap, getAlignmentX, getAlignmentY, getAncestorListeners, getAutoscrolls, getBaseline, getBaselineResizeBehavior, getBorder, getBounds, getClientProperty, getComponentGraphics, getComponentPopupMenu, getConditionForKeyStroke, getDebugGraphicsOptions, getDefaultLocale, getFontMetrics, getGraphics, getHeight, getInheritsPopupMenu, getInputMap, getInputMap, getInputVerifier, getInsets, getInsets, getListeners, getLocation, getMaximumSize, getMinimumSize, getNextFocusableComponent, getPopupLocation, getPreferredSize, getRegisteredKeyStrokes, getRootPane, getSize, getToolTipLocation, getToolTipText, getTopLevelAncestor, getTransferHandler, getVerifyInputWhenFocusTarget, getVetoableChangeListeners, getVisibleRect, getWidth, getX, getY, grabFocus, hide, isDoubleBuffered, isLightweightComponent, isManagingFocus, isOpaque, isOptimizedDrawingEnabled, isPaintingForPrint, isPaintingOrigin, isPaintingTile, isRequestFocusEnabled, isValidateRoot, paint, paintBorder, paintChildren, paintComponent, paintImmediately, paintImmediately, print, printAll, printBorder, printChildren, printComponent, processComponentKeyEvent, processKeyEvent, processMouseEvent, processMouseMotionEvent, putClientProperty, registerKeyboardAction, registerKeyboardAction, removeAncestorListener, removeVetoableChangeListener, repaint, repaint, requestDefaultFocus, requestFocus, requestFocus, requestFocusInWindow, requestFocusInWindow, resetKeyboardActions, reshape, revalidate, scrollRectToVisible, setActionMap, setAlignmentX, setAlignmentY, setAutoscrolls, setBackground, setBorder, setComponentPopupMenu, setDebugGraphicsOptions, setDefaultLocale, setDoubleBuffered, setEnabled, setFocusTraversalKeys, setFont, setForeground, setInheritsPopupMenu, setInputMap, setInputVerifier, setMaximumSize, setMinimumSize, setNextFocusableComponent, setOpaque, setPreferredSize, setRequestFocusEnabled, setToolTipText, setTransferHandler, setUI, setVerifyInputWhenFocusTarget, setVisible, unregisterKeyboardAction, update`

    - ### Methods inherited from class java.awt.Container

      `add, add, add, add, add, addContainerListener, addImpl, addPropertyChangeListener, addPropertyChangeListener, applyComponentOrientation, areFocusTraversalKeysSet, countComponents, deliverEvent, findComponentAt, findComponentAt, getComponent, getComponentAt, getComponentAt, getComponentCount, getComponents, getComponentZOrder, getContainerListeners, getFocusTraversalKeys, getFocusTraversalPolicy, getLayout, getMousePosition, insets, invalidate, isAncestorOf, isFocusCycleRoot, isFocusCycleRoot, isFocusTraversalPolicyProvider, isFocusTraversalPolicySet, layout, list, list, locate, minimumSize, paintComponents, preferredSize, printComponents, processContainerEvent, processEvent, remove, remove, removeAll, removeContainerListener, setComponentZOrder, setFocusCycleRoot, setFocusTraversalPolicy, setFocusTraversalPolicyProvider, setLayout, transferFocusDownCycle, validate, validateTree`

    - ### Methods inherited from class java.awt.Component

      `action, add, addComponentListener, addFocusListener, addHierarchyBoundsListener, addHierarchyListener, addInputMethodListener, addKeyListener, addMouseListener, addMouseMotionListener, addMouseWheelListener, bounds, checkImage, checkImage, coalesceEvents, contains, createImage, createImage, createVolatileImage, createVolatileImage, disableEvents, dispatchEvent, enable, enableEvents, enableInputMethods, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, getBackground, getBounds, getColorModel, getComponentListeners, getComponentOrientation, getCursor, getDropTarget, getFocusCycleRootAncestor, getFocusListeners, getFocusTraversalKeysEnabled, getFont, getForeground, getGraphicsConfiguration, getHierarchyBoundsListeners, getHierarchyListeners, getIgnoreRepaint, getInputContext, getInputMethodListeners, getInputMethodRequests, getKeyListeners, getLocale, getLocation, getLocationOnScreen, getMouseListeners, getMouseMotionListeners, getMousePosition, getMouseWheelListeners, getName, getParent, getPeer, getPropertyChangeListeners, getPropertyChangeListeners, getSize, getToolkit, getTreeLock, gotFocus, handleEvent, hasFocus, imageUpdate, inside, isBackgroundSet, isCursorSet, isDisplayable, isEnabled, isFocusable, isFocusOwner, isFocusTraversable, isFontSet, isForegroundSet, isLightweight, isMaximumSizeSet, isMinimumSizeSet, isPreferredSizeSet, isShowing, isValid, isVisible, keyDown, keyUp, list, list, list, location, lostFocus, mouseDown, mouseDrag, mouseEnter, mouseExit, mouseMove, mouseUp, move, nextFocus, paintAll, postEvent, prepareImage, prepareImage, processComponentEvent, processFocusEvent, processHierarchyBoundsEvent, processHierarchyEvent, processInputMethodEvent, processMouseWheelEvent, remove, removeComponentListener, removeFocusListener, removeHierarchyBoundsListener, removeHierarchyListener, removeInputMethodListener, removeKeyListener, removeMouseListener, removeMouseMotionListener, removeMouseWheelListener, removePropertyChangeListener, removePropertyChangeListener, repaint, repaint, repaint, resize, resize, setBounds, setBounds, setComponentOrientation, setCursor, setDropTarget, setFocusable, setFocusTraversalKeysEnabled, setIgnoreRepaint, setLocale, setLocation, setLocation, setName, setSize, setSize, show, show, size, transferFocus, transferFocusBackward, transferFocusUpCycle`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Constructor Detail

    - #### AbstractObjectTable

          public AbstractObjectTable(AbstractObjectTableModel<T> model)

    - #### AbstractObjectTable

          public AbstractObjectTable(AbstractObjectTableModel<T> model,
                             EnvStore envStore)

  - ### Method Detail

    - #### setSelectionMode

          public void setSelectionMode(ListSelectionMode mode)

    - #### getModel

          public AbstractObjectTableModel<T> getModel()

      Overrides:
        `getModel` in class `javax.swing.JTable`

    - #### getSelectionModel

          public IndexSelectionModel getSelectionModel()

      Overrides:
        `getSelectionModel` in class `javax.swing.JTable`

    - #### setHeaderRenderer

          public void setHeaderRenderer(javax.swing.table.TableCellRenderer r)

    - #### addIndexChangeListener

          public void addIndexChangeListener(IndexChangeEvent.Listener l)

      Specified by:
        `addIndexChangeListener` in interface `Steppable`

    - #### removeIndexChangeListener

          public void removeIndexChangeListener(IndexChangeEvent.Listener l)

    - #### getEnvKey

          protected java.lang.String getEnvKey()

    - #### initFromEnvStore

          public void initFromEnvStore(EnvStore envStore)

      Restores all column sizes as they are stored in the EnvStore. Should be called AFTER the table has been fully layouted the the mainframe was packed.
      Specified by:
        `initFromEnvStore` in interface `EnvStorable`

    - #### addEnvProperties

          public void addEnvProperties(EnvMap props)

      Description copied from interface: `EnvStorable`
      This method is called on the implementing class in order to give it a chance to fill the passed Properties object with key-value pairs that should be saved in the environment properties file.
      Specified by:
        `addEnvProperties` in interface `EnvStorable`

    - #### deleteRow

          protected final int deleteRow(java.lang.Object obj)
                                 throws java.lang.Exception

      Is called by the the inner delete-selected-row Notify when fired. May be overridden if something special needs to happen before the object is actually deleted from the TableModel. Calls `dropObject(Object)` by default.
      Throws:
        `java.lang.Exception`
      See Also:
        `dropObject(Object)`

    - #### deleteRow

          protected void deleteRow(int rowIndex)
                            throws java.lang.Exception

      May be overridden if something special needs to happen before the object is actually deleted from the TableModel. Calls `dropObject(int)` by default.
      Throws:
        `java.lang.Exception`
      See Also:
        `dropObject(int)`

    - #### adjustSelection

          protected void adjustSelection(int rowIndex)

    - #### selectRow

          public void selectRow(int rowIndex)

    - #### selectRow

          public void selectRow(int rowIndex,
                       boolean isScrollVisible)

      Selects the specified row and scrolls it to be visible.

    - #### scrollToRow

          public void scrollToRow(int rowIndex)

      Scrolls to the given row index to make it visible.

    - #### hasRangeSelected

          public boolean hasRangeSelected()

      Tells if a range selection exists. At least two rows must be selected in a range selection.

    - #### getSelectedIndex

          public int getSelectedIndex()

      Returns the index of the currently selected row. Note that if a range is selected, the current row is the one, that has the lead selection index - in contrast to getSelectedRow() which always returns the first selected row.

    - #### isEmpty

          public boolean isEmpty()

      Specified by:
        `isEmpty` in interface `Steppable`

    - #### clear

          public final void clear()

      Drops all rows from the underlying TableModel
      Specified by:
        `clear` in interface `Clearable`

    - #### isSortAscending

          public boolean isSortAscending()

    - #### setSortAscending

          public void setSortAscending(boolean isAscending)

    - #### hasSelection

          public boolean hasSelection()

      Returns true if any row is selected.

    - #### setObject

          public void setObject(int index,
                       T obj)

      Delegates to the TableModel and ensures that a selection event is fired if the affected object is currently selected. So SelectionListeners are notified and can react on the change.

    - #### selectObject

          public java.lang.Object selectObject(T obj)

      Searches the given Object in the TableModel and selects it. Objects are compared with their equals() method.
      Returns:
        true if it could be selected, false if it could not be found in the TableModel.

    - #### selectObject

          public java.lang.Object selectObject(int index)

      Selects the row at the given index.

    - #### addObject

          public int addObject(T obj)

      Inserts a record for the given object in a way that it keeps the current selection (if any). This behavior is needed by clients because inserts are notified via HWMessage

    - #### addObjects

          public void addObjects(java.util.Collection<T> objs)

    - #### addObjects

          public void addObjects(T[] objs)

    - #### getSelectedObject

          public T getSelectedObject()

      Returns the Object in the currently selected row. Note that if a range is selected, the current row is the one, that has the lead selection index.

    - #### getSelectedObjects

          public java.util.List<T> getSelectedObjects()

      Returns all Objects in the currently selected rows.

    - #### getAllObjects

          public java.util.List<T> getAllObjects()

      Returns all Objects contained in the TableModel.

    - #### deleteObject

          public final int deleteObject(java.lang.Object obj)
                                 throws java.lang.Exception

      Throws:
        `java.lang.Exception`

    - #### dropObject

          public int dropObject(java.lang.Object obj)

      Drops the given object from the table if it can be found based on its equals() method.
      Returns:
        the index where the object was found, -1 if it was not found

    - #### dropObject

          public int dropObject(java.lang.Object obj,
                       boolean isAdjustSelection)

    - #### dropObject

          public T dropObject(int rowIndex)

      Drops the object at the given index from the table.
      Returns:
        the Object that was found at the given index, null if none was found

    - #### getObject

          public T getObject(int index)

      Delegates to the underlying TableModel.

    - #### indexOf

          public int indexOf(java.lang.Object obj)

      Delegates to the underlying TableModel.

    - #### toDumpString

          public DumpString toDumpString(DumpString s)

      Description copied from interface: `Dumpable`
      This method allows subclasses to add values to the existing DumpString of the superclass. Usually subclasses only need to override this method.
      Specified by:
        `toDumpString` in interface `Dumpable`

    - #### toString

          public ToString toString(ToString s)

      Description copied from interface: `Dumpable`
      This method allows subclasses to add values to the existing ToString of the superclass. Usually subclasses only need to override this method.
      Specified by:
        `toString` in interface `Dumpable`

    - #### toDumpString

          public java.lang.String toDumpString()

      Description copied from interface: `Dumpable`
      Returns a multi-line String that shows the values (name=value) of all important state variables of this object.
      Specified by:
        `toDumpString` in interface `Dumpable`

    - #### toString

          public java.lang.String toString()

      Description copied from interface: `Dumpable`
      Returns a single line String that shows the values of the most important state variables of this object. This is intentionally the same toString() method which is already provided by Object per se.
      Specified by:
        `toString` in interface `Dumpable`
      Overrides:
        `toString` in class `java.awt.Component`

    - #### addListSelectionListener

          public void addListSelectionListener(javax.swing.event.ListSelectionListener l)

    - #### removeListSelectionListener

          public void removeListSelectionListener(javax.swing.event.ListSelectionListener l)

    - #### addTableModelListener

          public void addTableModelListener(javax.swing.event.TableModelListener l)

    - #### removeTableModelListener

          public void removeTableModelListener(javax.swing.event.TableModelListener l)

    - #### addDataLoadListener

          public void addDataLoadListener(DataLoadEvent.Listener l)

      Specified by:
        `addDataLoadListener` in interface `DataLoadEvent.Source`

    - #### removeDataLoadListener

          public void removeDataLoadListener(DataLoadEvent.Listener l)

      Specified by:
        `removeDataLoadListener` in interface `DataLoadEvent.Source`

    - #### addActionListener

          public void addActionListener(java.awt.event.ActionListener l)

      Adds a listener to react on double clicks.

    - #### removeActionListener

          public void removeActionListener(java.awt.event.ActionListener l)

    - #### matchesTypedString

          protected boolean matchesTypedString(java.lang.Object obj,
                                   java.lang.String typedStr)

    - #### getRecordCount

          public int getRecordCount()

      Specified by:
        `getRecordCount` in interface `Steppable`

    - #### isChangeConfirmed

          public boolean isChangeConfirmed()

      Specified by:
        `isChangeConfirmed` in interface `Steppable`

    - #### first

          public void first()

      Specified by:
        `first` in interface `Steppable`

    - #### last

          public void last()

      Specified by:
        `last` in interface `Steppable`

    - #### next

          public boolean next()

      Specified by:
        `next` in interface `Steppable`

    - #### previous

          public boolean previous()

      Specified by:
        `previous` in interface `Steppable`

    - #### setCurrentIndex

          public boolean setCurrentIndex(int rowIndex)

      Specified by:
        `setCurrentIndex` in interface `Steppable`

    - #### getCurrentIndex

          public int getCurrentIndex()

      Specified by:
        `getCurrentIndex` in interface `Steppable`

    - #### getPreferredScrollableViewportSize

          public java.awt.Dimension getPreferredScrollableViewportSize()

      Specified by:
        `getPreferredScrollableViewportSize` in interface `javax.swing.Scrollable`
      Overrides:
        `getPreferredScrollableViewportSize` in class `javax.swing.JTable`

    - #### isSelectionEmpty

          public boolean isSelectionEmpty()

    - #### dumpSelectedObject

          public void dumpSelectedObject()

    - #### configurePreferredDumpDialogColumns

          protected int configurePreferredDumpDialogColumns()

    - #### configurePreferredDumpDialogRows

          protected int configurePreferredDumpDialogRows()

    - #### load

          public final void load()
                          throws java.lang.Exception

      Throws:
        `java.lang.Exception`

    - #### getActionDeleteSelectedRow

          public de.esprit.common.gui.table.AbstractObjectTable.MyDeleteSelectedRowAction getActionDeleteSelectedRow()

      Deletes the selected record from the table.

    - #### getActionDropSelectedRow

          public de.esprit.common.gui.table.AbstractObjectTable.MyDropSelectedRowAction getActionDropSelectedRow()

    - #### getActionClearContent

          public de.esprit.common.gui.table.AbstractObjectTable.MyTableClearAction getActionClearContent()

    - #### getActionClearSelection

          public de.esprit.common.gui.table.AbstractObjectTable.MyClearSelectionAction getActionClearSelection()

    - #### getActionDumpTableData

          public de.esprit.common.gui.table.AbstractObjectTable.MyDumpTableDataAction getActionDumpTableData()

    - #### getActionLoadTableData

          public de.esprit.common.gui.table.AbstractObjectTable.MyLoadTableDataAction getActionLoadTableData()

      Clears and reloads the table data.

    - #### getActionRowDetails

          public de.esprit.common.gui.table.AbstractObjectTable.MyRowDetailsAction getActionRowDetails()

      Pops up a TableRowDumpDialog showing the (Dumpable) details of the selected record. Therefore the object in the table must implement the Dumpable interface.

Copyright © 2014 EsprIT-Systems. All Rights Reserved.